## mpsolve 3.2.3

=== examples/octave/DESCRIPTION ===
Name: MPSolve
Version: 3.1.7
Date: 2013-10-18
Categories: rootfinding, polynomial
Author: Leonardo Robol <leonardo.robol@sns.it>
Maintainer: Leonardo Robol <leonardo.robol@sns.it>
Title: MPSolve
Description: A package for approximating the roots of polynomials
 with an arbitrary number of digits. 
License: GPL version 3 or later

## mpsolve 3.2.1

=== debian/changelog ===
mpsolve (3.2.1-7) unstable; urgency=medium

  * debian/control
    - Update Maintainer to Debian Math Team.
  * debian/libmps3.symbols
    - Remove redundant lines.
    - Mark some symbols for template instantiations as optional as they may
      be optimized out by LTO (Closes: #1015548).

 -- Doug Torrance <dtorrance@debian.org>  Tue, 19 Jul 2022 23:54:36 -0400

mpsolve (3.2.1-6) unstable; urgency=medium

  * debian/control
    - Update my email address (now a Debian Developer).
    - Switch from dh-python to dh-sequence-python3 in Build-Depends; will
      simplify d/rules.
    - Bump Standards-Version to 4.6.1.
    - Update Vcs-* URL's (science-team -> math-team).
    - Add "MPSolve" to descriptions for binary packages
  * debian/copyright
    - Update my copyright years and email address.
  * debian/gbp.conf
    - Add file; set default debian-branch to debian/latest; recommended by
      DEP-14.
  * debian/patches
    - Update my email address in Author fields.
  * debian/rules
    - Drop "--with python3"; unnecessary now that we have
      dh-sequence-python3 in Build-Depends.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 28 May 2022 22:57:40 -0400

mpsolve (3.2.1-5) unstable; urgency=medium

  * debian/patches/autoconf-2.70.patch
    - New patch; adjust configure.ac to work with autoconf 2.70
      (Closes: #997249).

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 01 Nov 2021 11:51:45 -0400

mpsolve (3.2.1-4) unstable; urgency=medium

  * debian/control
    - Set Architecture for xmpsolve to linux-any; requires Qt, which isn't
      available on kFreeBSD architectures.
    - Limit qtbase5-dev in Build-Depends to linux-any.
    - Drop qtbase5-dev-tools from Build-Depends; redundant as it is a
      dependency of qtbase5-dev.
    - Remove autoconf, automake, and libtool from Build-Depends; redundant
      as they are dependencies of debhelper (via dh-autoreconf).
    - Drop deprecated GTK2 as option in Build-Depends.
    - Switch from libcairo2-dev to virtual libcairo-dev in Build-Depends
      to simplify any future transitions.
    - Remove dummy package libgmp3-dev as backup to libgmp-dev in
      Build-Depends.
    - Drop libmpfr-dev from Build-Depends; not used.
  * debian/rules
    - Don't enable tcmalloc on architectures that give us a "cannot
      allocate memory in static TLS block" error.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 22 Aug 2021 22:14:41 -0400

mpsolve (3.2.1-3) unstable; urgency=medium

  * debian/{*.install,tests/control}
    - Clean up using wrap-and-sort.
  * debian/control
    - Drop libtcmalloc-minimal* from Build-Depends and replace them with
      libgoogle-perftools-dev, which actually contains the unversioned .so
      file for linking.
    - Omit libgoogle-perftools-dev from Build-Depends for architectures on
      which it doesn't (currently) exist.
    - Bump Standards-Version to 4.6.0
  * debian/rules
    - New override_dh_auto_configure target; only enable tcmalloc if
      libgoogle-perftools-dev is installed.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 22 Aug 2021 15:22:37 -0400

mpsolve (3.2.1-2) unstable; urgency=medium

  * Source-only upload for migration to testing.
  * debian/control
    - Set libmps-dev and libmps-fortran-dev to "Multi-Arch: same" as
      suggested by Multi-Arch hinter.

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 19 Oct 2020 16:09:58 -0400

mpsolve (3.2.1-1) unstable; urgency=low

  * Initial release (Closes: #958919).

 -- Doug Torrance <dtorrance@piedmont.edu>  Tue, 21 Jul 2020 21:39:56 -0400

=== debian/control ===
Source: mpsolve
Section: science
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: bison,
               check,
               debhelper-compat (= 13),
               dh-sequence-python3,
               flex,
               libcairo-dev,
               libgmp-dev,
               libgoogle-perftools-dev [!alpha !hppa !hurd-i386 !ia64 !m68k
                                        !sh4 !sparc64 !x32],
               libgtk-3-dev,
               python3-dev,
               qtbase5-dev [linux-any]
Standards-Version: 4.6.1
Homepage: https://numpi.dm.unipi.it/software/mpsolve
Vcs-Git: https://salsa.debian.org/math-team/mpsolve.git
Vcs-Browser: https://salsa.debian.org/math-team/mpsolve
Rules-Requires-Root: no

Package: mpsolve
Architecture: any
Depends: libmps3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Multiprecision polynomial solver (command line version)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the command line version of MPSolve.

Package: libmps3
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Multiprecision polynomial solver (shared library)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the libmps shared library of MPSolve.

Package: libmps-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libmps3 (= ${binary:Version}), ${misc:Depends}
Description: Multiprecision polynomial solver (development)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the development headers and the .so library of MPSolve.

Package: libmps-fortran0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Multiprecision polynomial solver (FORTRAN module)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the module MPS that can be used to call MPSolve from
 FORTRAN programs.

Package: libmps-fortran-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libmps-fortran0 (= ${binary:Version}), ${misc:Depends}
Description: Multiprecision polynomial solver (FORTRAN module development)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the module MPS that can be used to compile FORTRAN
 programs using MPSolve.

Package: python3-mpsolve
Architecture: all
Section: python
Depends: libmps3 (>= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Description: Multiprecision polynomial solver (Python interface)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the Python interface to MPSolve.

Package: xmpsolve
Architecture: linux-any
Depends: libmps3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Multiprecision polynomial solver (graphical version)
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 .
 This package contains the graphical version of MPSolve.

Package: mandelbrot-solver
Architecture: any
Depends: libmps3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Solver for Mandelbrot polynomials based on MPSolve
 A polynomial rootfinder that can determine arbitrary precision approximations
 with guaranteed inclusion radii.
 It supports exploiting of polynomial structures such as sparsisty and allows
 for polynomial implicitly defined or in some non standard basis.
 This binary, provided as an example of custom polynomial
 implementation in the MPSolve package, uses the particular structure
 of this family of polynomials to develop an efficient solver that
 exhibit experimental O(n^2) complexity.
 .
 This package contains the specialization of mpsolve to Mandelbrot polynomials.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# only enable tcmalloc if:
# 1. it's available on the given architecture (i.e., we haven't blacklisted
#    libgoogle-perftools-dev in Build-Depends d/control)
HAVE_TCMALLOC := $(shell dpkg-query -W libgoogle-perftools-dev 2> /dev/null)

# 2.  it doesn't give us a "cannot allocate memory in static TLS block" error.
#     possibly related: https://bugzilla.redhat.com/1483558
NO_TCMALLOC_ERROR := $(filter-out \
	arm64 armel armhf mips64el mipsel s390x riscv64, \
	$(DEB_HOST_ARCH))

ENABLE_TCMALLOC := $(if $(and $(HAVE_TCMALLOC), $(NO_TCMALLOC_ERROR)), \
	--enable-tcmalloc, --disable-tcmalloc)

override_dh_auto_configure:
	dh_auto_configure -- $(ENABLE_TCMALLOC)

=== debian/watch ===
# don't use @ARCHIVE_EXT@, as that will match *-windows.zip files which uscan
# thinks are newer versions
version=4
https://numpi.dm.unipi.it/downloads/mpsolve/\
@PACKAGE@@ANY_VERSION@(?i)\.(?:tar\.xz|tar\.bz2|tar\.gz|tgz|tbz|txz)

## mpsolve 3.2.3

=== debian/changelog ===
mpsolve (3.2.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Bump Standards-Version to 4.7.2.
  * debian/copyright
    - Replace old FSF address in LGPL-2.1 stanza.
  * debian/libmps*.lintian-overrides
    - Remove package-name-doesnt-match-sonames overrides; no longer flagged
      by lintian for t64 transition libraries.
  * debian/libmps3t64.symbols
    - Add new symbols.
    - Add missing "@Base" and version number on symbol.
  * debian/patches
    - Remove directory; patches applied upstream
  * debian/rules
    - Regenerate the bison files, as the ones shipped by upstream were
      generated by BSD yacc and result in a compilation error due to
      implicitly defining 'yyparse'.
  * debian/watch
    - Update with new download location.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 03 Sep 2025 10:43:57 -0400

mpsolve (3.2.1-11) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.7.0.
  * debian/copyright
    - Update my copyright years.
  * debian/gbp.conf
    - Set pristine-tar to True
  * debian/patches/gcc-15
    - New patch; don't define mps_boolean as enum in C23
      (Closes: #1097416).

 -- Doug Torrance <dtorrance@debian.org>  Tue, 18 Feb 2025 19:38:31 -0500

mpsolve (3.2.1-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062951

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 20:24:05 +0000

mpsolve (3.2.1-10) unstable; urgency=medium

  * debian/control
    - Switch Section to math.
    - Add hurd-amd64 and remove x32 from list of architectures without
      libgoogle-perftools-dev in Build-Depends.
  * debian/copyright
    - Bump my copyright years.
  * debian/rules
    - Disable tcmalloc on loong64.  Thanks to JiaLing Zhang for the patch!
      (Closes: #1057444).
  * debian/libmps3.symbols
    - Split __do_uninit_fill_n symbols into 32- and 64-bit versions.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 11 Dec 2023 07:23:39 -0500

mpsolve (3.2.1-9) unstable; urgency=medium

  * debian/clean
    - New file; remove generated __pycache__ directory (Closes: #1048417).
  * debian/libmps3.symbols
    - Add new symbols that appear when building with GCC 12.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 14 Aug 2023 23:17:45 -0400

mpsolve (3.2.1-8) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.6.2.
    - Update Homepage URL.
  * debian/watch
    - Update download link.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 20 Jun 2023 11:11:30 -0400

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,29 @@
 Source: mpsolve
-Section: science
+Section: math
 Priority: optional
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
-Build-Depends: bison,
+Build-Depends: dpkg-dev (>= 1.22.5), bison,
                check,
                debhelper-compat (= 13),
                dh-sequence-python3,
                flex,
                libcairo-dev,
                libgmp-dev,
-               libgoogle-perftools-dev [!alpha !hppa !hurd-i386 !ia64 !m68k
-                                        !sh4 !sparc64 !x32],
+               libgoogle-perftools-dev [!alpha !hppa !hurd-i386 !hurd-amd64
+                                       !ia64 !m68k !sh4 !sparc64],
                libgtk-3-dev,
                python3-dev,
                qtbase5-dev [linux-any]
-Standards-Version: 4.6.1
-Homepage: https://numpi.dm.unipi.it/software/mpsolve
+Standards-Version: 4.7.2
+Homepage: https://numpi.dm.unipi.it/scientific-computing-libraries/mpsolve/
 Vcs-Git: https://salsa.debian.org/math-team/mpsolve.git
 Vcs-Browser: https://salsa.debian.org/math-team/mpsolve
 Rules-Requires-Root: no
 
 Package: mpsolve
 Architecture: any
-Depends: libmps3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libmps3t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Multiprecision polynomial solver (command line version)
  A polynomial rootfinder that can determine arbitrary precision approximations
  with guaranteed inclusion radii.
@@ -32,7 +32,10 @@
  .
  This package contains the command line version of MPSolve.
 
-Package: libmps3
+Package: libmps3t64
+Provides: ${t64:Provides}
+Replaces: libmps3
+Breaks: libmps3 (<< ${source:Version})
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -50,7 +53,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libmps3 (= ${binary:Version}), ${misc:Depends}
+Depends: libmps3t64 (= ${binary:Version}), ${misc:Depends}
 Description: Multiprecision polynomial solver (development)
  A polynomial rootfinder that can determine arbitrary precision approximations
  with guaranteed inclusion radii.
@@ -59,7 +62,10 @@
  .
  This package contains the development headers and the .so library of MPSolve.
 
-Package: libmps-fortran0
+Package: libmps-fortran0t64
+Provides: ${t64:Provides}
+Replaces: libmps-fortran0
+Breaks: libmps-fortran0 (<< ${source:Version})
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -78,7 +84,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libmps-fortran0 (= ${binary:Version}), ${misc:Depends}
+Depends: libmps-fortran0t64 (= ${binary:Version}), ${misc:Depends}
 Description: Multiprecision polynomial solver (FORTRAN module development)
  A polynomial rootfinder that can determine arbitrary precision approximations
  with guaranteed inclusion radii.
@@ -91,7 +97,7 @@
 Package: python3-mpsolve
 Architecture: all
 Section: python
-Depends: libmps3 (>= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
+Depends: libmps3t64 (>= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
 Description: Multiprecision polynomial solver (Python interface)
  A polynomial rootfinder that can determine arbitrary precision approximations
  with guaranteed inclusion radii.
@@ -102,7 +108,7 @@
 
 Package: xmpsolve
 Architecture: linux-any
-Depends: libmps3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libmps3t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Multiprecision polynomial solver (graphical version)
  A polynomial rootfinder that can determine arbitrary precision approximations
  with guaranteed inclusion radii.
@@ -113,7 +119,7 @@
 
 Package: mandelbrot-solver
 Architecture: any
-Depends: libmps3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libmps3t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Solver for Mandelbrot polynomials based on MPSolve
  A polynomial rootfinder that can determine arbitrary precision approximations
  with guaranteed inclusion radii.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # 2.  it doesn't give us a "cannot allocate memory in static TLS block" error.
 #     possibly related: https://bugzilla.redhat.com/1483558
 NO_TCMALLOC_ERROR := $(filter-out \
-	arm64 armel armhf mips64el mipsel s390x riscv64, \
+	arm64 armel armhf mips64el mipsel s390x riscv64 loong64, \
 	$(DEB_HOST_ARCH))
 
 ENABLE_TCMALLOC := $(if $(and $(HAVE_TCMALLOC), $(NO_TCMALLOC_ERROR)), \
@@ -23,3 +23,15 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(ENABLE_TCMALLOC)
+
+# stash upstream's bsd yacc-generated files so bison regenerates them
+# and we don't get an implicit declaration compiler error
+# https://github.com/robol/MPSolve/issues/48
+YACC_PARSER = src/libmps/monomial/yacc-parser
+execute_before_dh_auto_build:
+	mv $(YACC_PARSER).c $(YACC_PARSER).c.bak
+	mv $(YACC_PARSER).h $(YACC_PARSER).h.bak
+
+execute_after_dh_auto_test:
+	mv $(YACC_PARSER).c.bak $(YACC_PARSER).c
+	mv $(YACC_PARSER).h.bak $(YACC_PARSER).h

=== debian/tests/control ===
Test-Command: gcc examples/C/root_of_unity.c -lm -lgmp -lmps -pthread &&
  mpsolve -p "x^4-6*x^9+6/7*x + 5"
Depends: build-essential, libgmp-dev, @

=== debian/watch ===
version=4
https://numpi.dm.unipi.it/scientific-computing-libraries/mpsolve/ \
.*/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
